#ifndef _DS1302_H
#define _DS1302_H
extern "C"
{
  #include <RTC_define.h>
  #include <inttypes.h>
  #include <avr/io.h>
  #define F_CPU 16000000L
  #include <util/delay.h>
}

#define RTC_SCLK_DDR DDRD
#define RTC_SCLK_PORT PORTD
#define RTC_SCLK_PIN 3

#define RTC_IO_DDR DDRD
#define RTC_IO_PORT PORTD
#define RTC_IO_INPORT	PIND
#define RTC_IO_PIN 4

#define RTC_CS_DDR DDRD
#define RTC_CS_PORT PORTD
#define RTC_CS_PIN 6




#define DS1302_CLK_OUT 	RTC_SCLK_DDR |= (1<<RTC_SCLK_PIN)
#define DS1302_CLK_H	RTC_SCLK_PORT |= (1<<RTC_SCLK_PIN)
#define DS1302_CLK_L	RTC_SCLK_PORT &=~(1<<RTC_SCLK_PIN)

#define DS1302_CS_OUT	RTC_CS_DDR |= (1<<RTC_CS_PIN)
#define DS1302_CS_H	RTC_CS_PORT |=(1<<RTC_CS_PIN)
#define DS1302_CS_L	RTC_CS_PORT &=~(1<<RTC_CS_PIN)

#define DS1302_IO_OUT	RTC_CS_DDR |= (1<<RTC_IO_PIN)
#define DS1302_IO_IN	RTC_CS_DDR &=~(1<<RTC_IO_PIN)
#define DS1302_IO_H	RTC_CS_PORT |= (1<<RTC_IO_PIN)
#define DS1302_IO_L	RTC_CS_PORT &=~(1<<RTC_IO_PIN)
#define DS1302_IO_INPORT RTC_IO_INPORT

#define BCDtoINT(x) ((((x)>>4)*10)+((x)&15))
#define INTtoBCD(x) ((((x)/10)<<4)+((x)%10))

#define C_WP  0x8E



class DS1302{
	
	public:
		
		DS1302();
		void Write_Byte(uint8_t d);
		uint8_t Read_Byte(void);
		void Write1302(uint8_t ucAddr, uint8_t ucDa);
		uint8_t Read1302(uint8_t ucAddr);
		void gettime (RTC*);					/* Get time */
		void settime (const RTC*);				/* Set time */
};
#endif
